unit ExceptionHandlingU;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    dlgSave: TSaveDialog;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure A;
    procedure B;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
{$ifdef LINUX}
  Libc,
{$endif}
{$ifdef MSWINDOWS}
  Windows,
{$endif}
  Math;

procedure TForm1.Button1Click(Sender: TObject);
var
  Radius, Area, Volume: Double;
  RadiusStr: String;
begin
  RadiusStr := '1.0';
  if InputQuery('Trigonometry 101', 'Enter a radius', RadiusStr) then
    try
      Radius := StrToFloat(RadiusStr);
      Area := Pi * Sqr(Radius);
      Volume := Pi * Power(Radius, 3) * 4/3;
      ShowMessageFmt(
        'A circle with radius %g has area %g'#10 +
        'A sphere with radius %g has volume %g'#10 +
        'Calculation performed at %s on %s',
        [Radius, Area, Radius, Volume,
         TimeToStr(Time), DateToStr(Date)])
    except
      on EConvertError do
        MessageDlg(
          'Your entry was not recognised as a valid number',
          mtError, [mbOk], 0)
    end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  TF: TextFile;
begin
  if dlgSave.Execute then
    try
      AssignFile(TF, dlgSave.FileName);
      Append(TF);
      WriteLn(TF, 'Hello world');
      CloseFile(TF)
    except
      on E: EInOutError do
        case E.ErrorCode of
        {$ifdef LINUX}ENOENT{$endif}{$ifdef MSWINDOWS}ERROR_FILE_NOT_FOUND{$endif}:
           ShowMessage('"%s" cannot be located', [dlgSave.FileName]);
        {$ifdef LINUX}EACCES{$endif}{$ifdef MSWINDOWS}ERROR_ACCESS_DENIED{$endif}:
           ShowMessage('You do not have permission to overwrite this file');
        else
          if E.ErrorCode < 100 then
            ShowMessage('I/O Error'#10#9'Error code: %d'#10#9 +
              'Error msg: %s', [E.ErrorCode, SysErrorMessage(E.ErrorCode)])
          else
            ShowMessage('I/O Error'#10#9'Error code: %d'#10#9 +
              'Error msg: %s', [E.ErrorCode, E.Message]);
        end;
    end
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  //more code
  A
  //more code
end;

procedure TForm1.A;
begin
  try
    //more code
    B
    //more code
  except
    on E: EConvertError do
    begin
      ShowMessage('We just logged a problem:'#10#10 +
        'A %s exception occurred, saying:'#10'"%s"',
      [E.ClassName, E.Message])
    end
  end
end;

procedure TForm1.B;
var
  Radius, Area: Double;
  RadiusStr: String;
begin
  RadiusStr := '1.0';
  if InputQuery('Trigonometry 101', 'Enter a radius', RadiusStr) then
  begin
    Radius := StrToFloat(RadiusStr);
    Area := Pi * Sqr(Radius);
    ShowMessageFmt('A circle with radius %g has area %g', [Radius, Area])
  end
end;

end.
                             ;